<?php
/**
# version	2.5
# author	Ulli Storck
# license	GPL 2.0
 */

/** no direct access: ensure this file is being included by a parent file */
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }


class modcbrandomuserHelper
{
	const NO_SELECTION		= '- select entry -';

	/**
	 *
	 * @param object $params
	 * @return randuser  array
	 */
	public function getRandomUser($params)
	{
		global $_CB_database;

		$user_format 			= (int)$params->get('user_format', 0);
		$avatar_type			= (int)$params->get('avatar_type', 0);
		$show_without_avatar	= (int)$params->get('show_without_avatar', 1);
		
		$condition_enabled		= (int)$params->get('condition_enabled', 0);
		$condition_field_1		= $params->get('condition_field_1', modcbrandomuserHelper::NO_SELECTION);
		$condition_operator_1 	= (int)$params->get('condition_operator_1', 0);
		$condition_value_1		= $params->get('condition_value_1', '');
		$condition_field_2		= $params->get('condition_field_2', modcbrandomuserHelper::NO_SELECTION);
		$condition_operator_2 	= (int)$params->get('condition_operator_2', 0);
		$condition_value_2		= $params->get('condition_value_2', '');
		$condition_logical		= (int)$params->get('condition_logical', 0);
		
		$add_fields_enabled		= (int)$params->get('add_fields_enabled', 0);
		$add_fields_type		= (int)$params->get('add_fields_type', 0);
		$add_fields_alignment	= (int)$params->get('add_fields_alignment', 0);
		
		$add_fields				=	array(
										$params->get('add_field_1', modcbrandomuserHelper::NO_SELECTION),
										$params->get('add_field_2', modcbrandomuserHelper::NO_SELECTION),
										$params->get('add_field_3', modcbrandomuserHelper::NO_SELECTION),
										$params->get('add_field_4', modcbrandomuserHelper::NO_SELECTION),
										$params->get('add_field_5', modcbrandomuserHelper::NO_SELECTION)
									);
		
		$avatar_image_url 	= '';
		$user_name			= '';
		$randuser			= null;
		$condition_where	= '';
		$avatar_where		= '';

		// tablenames
		$table_comprofiler			= '#__comprofiler';
		$table_users				= '#__users';
		$table_comprofiler_fields	= '#__comprofiler_fields';

		// get excluded users
		$filter_userids = trim( $params->get( 'filter_userids', "" ) );		
		if ( $filter_userids != '' ) {
			$tmp_uids = explode( ',', $filter_userids );
			foreach ($tmp_uids as $ku => $uu ) {
				$tmp_uids[$ku] = (int) $uu;
			}
			$filter_userids = ' AND u.id not in (' . implode( ',', $tmp_uids ) . ')';
		}
		
		// check for avatar condition
		if (0 == $show_without_avatar) {
			$avatar_where =  ' AND b.avatarapproved AND b.avatar ';
		}
				
		// create conditions
		if ($condition_enabled && ($condition_field_1 != modcbrandomuserHelper::NO_SELECTION)) {
			
			// first condition
			$operator_1			= modcbrandomuserHelper::getConditionOperator($condition_operator_1);
			$fieldAndValue_1	= modcbrandomuserHelper::getFieldAndValue($condition_field_1, $condition_value_1, $table_comprofiler);
			
			$condition_where = ' AND ' . $fieldAndValue_1[0] . ' ' . $operator_1 . ' ' . $fieldAndValue_1[1];
			
			// second condition
			if (($condition_logical > 0) && ($condition_field_2 != modcbrandomuserHelper::NO_SELECTION)) {
				switch ($condition_logical) {
					case 1:
						$logical_op = ' AND ';
						break;
					case 2:
						$logical_op = ' OR ';
						break;
				}
								
				$operator_2			= modcbrandomuserHelper::getConditionOperator($condition_operator_2);
				$fieldAndValue_2	= modcbrandomuserHelper::getFieldAndValue($condition_field_2, $condition_value_2, $table_comprofiler);
				
				$condition_where .= $logical_op . $fieldAndValue_2[0] . ' ' . $operator_2 . ' ' . $fieldAndValue_2[1];
			}
		}

		// additional fields: get values
		$selected_fields_select = 'u.' . $_CB_database->NameQuote('id');	// use in select
		$selected_fields_where = ''; // use in where clause

		if ($add_fields_enabled) {
			// construct selected fields
			foreach ($add_fields as $add_field) {
				if (modcbrandomuserHelper::NO_SELECTION != $add_field) {
					$selected_fields_select .= ', ';
					$selected_fields_select .= 'b.' . $_CB_database->NameQuote($add_field);
					if ('' != $selected_fields_where) { $selected_fields_where .= ', '; }
					$selected_fields_where .= $_CB_database->Quote($add_field);
				}
			}
		}
		
		// get a random user and his field values
		$query = 'SELECT ' . $selected_fields_select
			. ' FROM ' . $_CB_database->NameQuote($table_users) . ' u, ' . $_CB_database->NameQuote($table_comprofiler) . ' b '
			. ' WHERE u.id = b.id AND b.approved AND u.block = 0 '
			. $avatar_where
			. $condition_where
			. $filter_userids
			. ' ORDER BY RAND() '
            . ' LIMIT 3 ';
		
		$_CB_database->setQuery($query);
		$user_fieldsall = $_CB_database->loadAssocList();
		
				
		foreach ($user_fieldsall as $user_fields){
		$uid = $user_fields['id'];
		
		
		if ($uid) {
			$cbUser =& CBuser::getInstance($uid);
			
			// avatar image: changed to my own implemenation because cbUserAvatar function does not alltimes work! (broken path...)
			$baseurl = JURI::root();
			$avatar = $cbUser->getUserData()->avatar;
			if ((strlen($avatar) > 0) && (1 == (int)$cbUser->getUserData()->avatarapproved)) {
				if ((0 == $avatar_type) && (false === strpos($avatar, 'gallery/'))) {
					$avatar = 'tn' . $avatar;
				}
				$avatar_image_url  = $baseurl . '/images/comprofiler/' . $avatar;
			}
			else {
				$avatar_image_url  = $baseurl . '/components/com_comprofiler/images/english/tnnophoto.jpg';
			}
			
			// user name
			switch ($user_format) {
				case 0:
					$user_name = $cbUser->getUserData()->name;
					break;
				case 1:
					$user_name = $cbUser->getUserData()->username;
					break;
				default:
					$user_name = $cbUser->getUserData()->username;
			}

			// additional fields: get field names for display
			$field_names = null;
			if ($add_fields_enabled && ('' != $selected_fields_where)) {
				$query = 'SELECT ' . $_CB_database->NameQuote('name') . ', ' . $_CB_database->NameQuote('title')
					. ' FROM ' . $_CB_database->NameQuote($table_comprofiler_fields)
					. ' WHERE ' . $_CB_database->NameQuote('name') . ' IN (' . $selected_fields_where . ')'
					. ' ORDER BY FIELD(' . $_CB_database->NameQuote('name') . ', ' . $selected_fields_where . ')';
				
				$_CB_database->setQuery($query);
				$field_names = $_CB_database->loadAssocList();
			}
		
			$randuser = array('user_fields' => $user_fields, 'field_names' => $field_names, 'name' => $user_name, 'avatar' => $avatar_image_url);
		}
		
		modcbrandomuserHelper::showitems($randuser,$params);
		}

		
	}
	
	
	private function showitems($randuser,$params){
		// cb framework
global $_CB_framework, $_CB_database, $ueConfig, $_SERVER;

if ( ! file_exists( JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_comprofiler' . DS . 'plugin.foundation.php') ) {
	echo 'CB not installed';
	return;
}
include_once(JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_comprofiler' . DS . 'plugin.foundation.php');

cbimport( 'cb.database' );
cbimport( 'language.front' );

// include the syndicate functions only once
require_once(dirname(__FILE__).DS.'helper.php');
		
		if(!$randuser) {
	echo $params->get('no_users', 'no user');
}
else {
	$avatar_image_width	= $params->get('avatar_width', 60); 
	$avatar_shown			= (int)$params->get('avatar_shown', 1);
	$add_fields_type		= (int)$params->get('add_fields_type', 1);
	$add_fields_alignment	= (int)$params->get('add_fields_alignment', 1);
	$add_fields_title		= (int)$params->get('add_fields_title', 2);
	
	$avatar			= '';
	$user_fields	= $randuser['user_fields'];
	$field_names	= $randuser['field_names'];

	$name				= htmlspecialchars($randuser['name'], ENT_QUOTES, 'UTF-8');
	$profilelink		= $_CB_framework->userProfileUrl( $user_fields['id'] );	
	
	if ($avatar_shown) {
		$avatar = '<img src="' . $randuser['avatar'] . '" title="' . $name . '" alt="' . $name . '" width="' . $avatar_image_width . '" />';
	}

	// additional fields
	$add_fields_html = '';
	if (null != $field_names) {
		foreach ($field_names as $field) {
			// show only fields with value
			if (null != $user_fields[$field['name']]) {
				if (('' != $add_fields_html) && (1 != $add_fields_type)) { $add_fields_html .= ', '; }
				if ((1 == $add_fields_type) && $add_fields_title) { $add_fields_html .= '<p>'; }
				switch ($add_fields_title) {
					case 1:
						$add_fields_html .= getLangDefinition($field['title']) . ': ';
						break;
					case 2:
						$add_fields_html .= '<strong>' . getLangDefinition($field['title']) . ':' . '</strong>' . ' ';
						break;
				}
								
				if (1 == $add_fields_type) { $add_fields_html .= ''; }
				
				// date needs special formatting
				$field_type = modcbrandomuserHelper::getFieldType($field['name'], '#__comprofiler');
				if (('date' == $field_type) || ('datetime' == $field_type)) {
					$date = JFactory::getDate($user_fields[$field['name']]);
					$add_fields_html .= JHTML::_('date', $date->toUnix(), JText::_('DATE_FORMAT_LC3')); 
				
				}
				else {
					$add_fields_html .= $user_fields[$field['name']];
				
				}

/*
				$dp = date_parse($user_fields[$field['name']]);
				if ($dp && !empty($dp->year)) {
					$date = JFactory::getDate($user_fields[$field['name']]);
					$add_fields_html .= JHTML::_('date', $date->toUnix(), JText::_('DATE_FORMAT_LC3')); 
				}
				else {
					$add_fields_html .= $user_fields[$field['name']];
				}
*/
			
				if ((1 == $add_fields_type) && $add_fields_title) { $add_fields_html .= '</p>'; }
			}	
		}		
	}
	
	$profile_html = '<a href="' . $profilelink . '">';
	$html = '<div class="usersl"><div class="usert">' . $profile_html . $avatar . '</a></div><div class="usern">' . $profile_html . $name . '</a></div>';
	
	//additional fields
	if ('' != $add_fields_html) {
		switch ($add_fields_alignment) {
			case 0:	// center
				$add_fields_align = 'center';
				break;
			case 1:	// left
				$add_fields_align = 'left';
				break;
			case 2:	// right
				$add_fields_align = 'right';
				break;
			default:	// center
				$add_fields_align = 'center';
		}

		$html .= '<div class="userdesc">' . $add_fields_html . '</div>';
	}
    $html .= "</div>";
	echo $html;
}
		}
	
	private function getConditionOperator($condition_operator)
	{
		switch ($condition_operator) {
			case 0:	// equal
				$operator = '=';
				break;
			case 1:	// not equal
				$operator = '!=';
				break;
			case 2:	// les than
				$operator = '<';
				break;
			case 3:	// greater
				$operator = '>';
				break;
			case 4:	// less than or equal to
				$operator = '<=';
				break;
			case 5:	// greater than or equal to
				$operator = '>=';
				break;
			case 6:	// in
				$operator = 'IN';
				break;
			case 7:	// not in
				$operator = 'NOT IN';
				break;
			case 8:	// like
				$operator = 'LIKE';
				break;
			default:
				$operator = '=';
		}

		return $operator;
	}
	

	//	
	// get type of condition field: this is tricky and not database indipendent! (mixed usage of orginal Joomla DB class and PHP mysql function needed
	//
	private function getFieldAndValue($condition_field, $condition_value, $table)
	{
		global $_CB_database;
		
		$type = modcbrandomuserHelper::getFieldType($condition_field, $table);

		switch ($type) {
			case 'int':
				$value = (int)$condition_value;
				$field = 'b.' . $_CB_database->NameQuote($condition_field);	
				break;
			case 'date':
			case 'datetime':	
				$value = 'Date(' . $_CB_database->Quote($condition_value) . ')';
				$field = 'Date(' . 'b.' . $_CB_database->NameQuote($condition_field) . ')';
				break;
			default: // string in most cases
				$value = $_CB_database->Quote($condition_value);
				$field = 'b.' . $_CB_database->NameQuote($condition_field);					
		}		
				
		return array($field, $value);
	}

	
	public function getFieldType($fieldname, $table)
	{
		global $_CB_database;
		
		$query = 'SELECT ' . $_CB_database->NameQuote($fieldname)
			. ' FROM ' . $_CB_database->NameQuote($table) . ' LIMIT 1';
		$_CB_database->setQuery($query);
		$result = $_CB_database->_db->query();
		$type = @mysql_field_type($result, 0);
		
		return $type;
	}
	
}
?>